"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cell = exports.cacher = exports.mapFactory = exports.factory = exports.shield = exports.throttle = exports.wait = exports.Debouncer = exports.debounce = exports.getRandomInt = exports.err = exports.sleep = exports.timeout = exports.isNumber = exports.falsePromise = exports.ox = void 0;
const ox = () => { };
exports.ox = ox;
exports.falsePromise = new Promise(exports.ox);
const isNumber = (n) => typeof n === "number" && !isNaN(n) && isFinite(n);
exports.isNumber = isNumber;
const timeout = (ms) => new Promise(r => setTimeout(r, ms));
exports.timeout = timeout;
exports.sleep = exports.timeout;
function err(msg) {
    throw new Error(msg);
}
exports.err = err;
function getRandomInt(min = 0, max = 1) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min) + min); //The maximum is exclusive and the minimum is inclusive
}
exports.getRandomInt = getRandomInt;
function debounce(fn, ms = 0) {
    let timeout, args;
    const execFn = () => fn(...args);
    return (...p) => {
        args = p;
        clearTimeout(timeout);
        timeout = setTimeout(execFn, ms);
    };
}
exports.debounce = debounce;
function Debouncer(fn, ms = 0) {
    let timeout, args, set, ret;
    const execFn = () => fn(...args);
    const setExec = () => {
        ret.exec = () => {
            clearTimeout(timeout);
            fn(...args);
            set = setExec;
            ret.exec = exports.ox;
        };
        set = exports.ox;
    };
    set = setExec;
    ret = {
        debounce: (...p) => {
            args = p;
            clearTimeout(timeout);
            timeout = setTimeout(execFn, ms);
            set();
        },
        exec: exports.ox,
        setAwaitTime: (x) => (ms = x),
    };
    return ret;
}
exports.Debouncer = Debouncer;
const wait = (fn) => {
    let execFn, waitedFn, promise;
    const ready = () => (execFn = start);
    const waiting = (...p) => {
        waitedFn = () => start(...p);
        return promise;
    };
    const start = (execFn = (...p) => __awaiter(void 0, void 0, void 0, function* () {
        execFn = waiting;
        waitedFn = ready;
        promise = fn(...p);
        yield promise;
        waitedFn();
    }));
    return (...p) => execFn(...p);
};
exports.wait = wait;
const throttle = (fn, ms) => (0, exports.wait)((...p) => {
    fn(...p);
    return (0, exports.timeout)(ms);
});
exports.throttle = throttle;
const shield = (fn, ms) => {
    const start = (...p) => {
        fn(...p);
        execFn = exports.ox;
        setTimeout(() => (execFn = start), ms);
    };
    let execFn = start;
    return (...p) => execFn(...p);
};
exports.shield = shield;
function factory(setterFunction, o = {}) {
    setterFunction = setterFunction.bind(o);
    return new Proxy(o, {
        get(target, prop) {
            var _a;
            return (_a = target[prop]) !== null && _a !== void 0 ? _a : (target[prop] = setterFunction(prop));
        },
    });
}
exports.factory = factory;
function mapFactory(setterFunction, m = new Map()) {
    setterFunction = setterFunction.bind(m);
    let v;
    const f = (prop) => { var _a; return (_a = m.get(prop)) !== null && _a !== void 0 ? _a : (m.set(prop, (v = setterFunction(prop))), v); };
    f.__map = m;
    return f;
}
exports.mapFactory = mapFactory;
function cacher(f, m = new Map()) {
    f = f.bind(m);
    let v;
    function fun(...params) {
        let prop;
        try {
            prop = JSON.stringify(params);
        }
        catch (e) {
            console.warn(e);
            prop = params;
        }
        return m.has(prop) ? m.get(prop) : m.set(prop, (v = f(...params))) && v;
    }
    fun._map = m;
    return fun;
}
exports.cacher = cacher;
const cell = (f, m) => (...args) => {
    const ret = f(m, ...args);
    return ret instanceof Promise ? ret.then(v => (m = v)) : (m = ret);
};
exports.cell = cell;
